package org.example.car.model;

import lombok.Data;

import java.io.Serializable;

@Data
public class R<T> implements Serializable {
    private static final long serialVersionUID = 1L;
    private Integer code;
    private String msg;
    private T data;

    public static <T> R<T> success(T object) {
        return new R<T>(1, object, "");
    }

    public static <T> R<T> success() {
        return new R<T>(1, null, "");
    }

    public static <T> R<T> error(String msg) {
        return new R<T>(0, null, msg);
    }


    public static <T> R<T> error(int code, String message) {
        return new R<T>(code, null, message);
    }


    public R(int code, T data, String msg) {
        this.code = code;
        this.data = data;
        this.msg = msg;
    }

    public R(int code, T data) {
        this(code, data, "");
    }

}
