package org.example.car.utils;

import org.example.car.controller.Tool;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.stream.Collectors;

public class FileUtil {

    public static List<String> listModels(String path) throws IOException {
        Path dir = Paths.get(path);
        return Files.walk(dir,1)
                .filter(p -> !Files.isDirectory(p))
                .map(p -> p.getFileName().toString())
                .map(FileUtil::removeExtension)
                .collect(Collectors.toList());
    }

    public static String removeExtension(String filename) {
        int pos = filename.lastIndexOf(".");
        if (pos == -1) {
            return filename;
        }
        return filename.substring(0, pos);
    }

}
